package betterwithengineering.te;


import betterwithengineering.BWE;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.module.Feature;
import cofh.thermalexpansion.util.managers.machine.SmelterManager;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.common.event.FMLInterModComms;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.relauncher.ReflectionHelper;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ThermalExpansion extends Feature {
    public static final String MODID = "thermalexpansion";

    public ThermalExpansion() {
        configName = "ThermalExpansion";
    }

    @Override
    public void setupConfig() {
        super.setupConfig();
    }

    @Override
    public void preInit(FMLPreInitializationEvent event) {
        removeSmelterRecipe(new ItemStack(Items.field_151133_ar), ItemStack.field_190927_a);
        addSmelterRecipe(6000, new ItemStack(Items.field_151133_ar), ItemStack.field_190927_a, new ItemStack(Items.field_191525_da, 7));

    }

    public static ItemStack SAND = new ItemStack(Blocks.field_150354_m);
    public static ItemStack SOUL_SAND = new ItemStack(Blocks.field_150425_aM);

    @Override
    public void postInit(FMLPostInitializationEvent event) {

        if (BWE.ConfigManager.thermalExpansion.hardcoreInductionSmelter) {
            ItemStack HELL_FIRE_INGOT = ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.CONCENTRATED_HELLFIRE);
            ItemStack DIAMOND_INGOT = ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DIAMOND_INGOT);
            Map<List<SmelterManager.ComparableItemStackSmelter>, SmelterManager.SmelterRecipe> recipes = ReflectionHelper.getPrivateValue(SmelterManager.class, null, "recipeMap");

            Iterator<SmelterManager.SmelterRecipe> iterator = recipes.values().iterator();
            while (iterator.hasNext()) {
                SmelterManager.SmelterRecipe recipe = iterator.next();
                if (recipe.getPrimaryOutput().func_77969_a(DIAMOND_INGOT)) {
                    iterator.remove();
                } else if (recipe.getSecondaryInput().func_77969_a(SAND)) {
                    ReflectionHelper.setPrivateValue(SmelterManager.SmelterRecipe.class, recipe, HELL_FIRE_INGOT, "secondaryInput");
                    ReflectionHelper.setPrivateValue(SmelterManager.SmelterRecipe.class, recipe, HELL_FIRE_INGOT, "secondaryInput");
                } else if (recipe.getSecondaryInput().func_77969_a(SOUL_SAND)) {
                    ReflectionHelper.setPrivateValue(SmelterManager.SmelterRecipe.class, recipe, HELL_FIRE_INGOT, "secondaryInput");
                }
            }
        }
    }

    public void addSmelterRecipe(int energy, ItemStack primary, ItemStack secondary, ItemStack output) {
        NBTTagCompound tag = new NBTTagCompound();
        tag.func_74768_a("energy", energy);
        tag.func_74782_a("primaryInput", primary.serializeNBT());
        tag.func_74782_a("secondaryInput", secondary.serializeNBT());
        tag.func_74782_a("primaryOutput", output.serializeNBT());
        FMLInterModComms.sendMessage(MODID, ADD_SMELTER_RECIPE, tag);
    }

    public void removeSmelterRecipe(ItemStack primary, ItemStack secondary) {
        NBTTagCompound tag = new NBTTagCompound();
        tag.func_74782_a("primaryInput", primary.serializeNBT());
        tag.func_74782_a("secondaryInput", secondary.serializeNBT());

        FMLInterModComms.sendMessage(MODID, REMOVE_SMELTER_RECIPE, tag);
    }

    public static final String ADD_SMELTER_RECIPE = "addsmelterrecipe";
    public static final String REMOVE_SMELTER_RECIPE = "removesmelterrecipe";
}
